
#include "main.h"


static SDL_Surface *ptrScreen = NULL;
static SDL_Rect dim;

static void DisplayInit(void);
static uint32_t GetPx(SDL_Surface *surface, uint16_t x, uint16_t y);
static SDL_Surface *ChargerImage(const char *name);

int main(int argc, char** argv) {

  SDL_Rect dstClip;
  int cnt;
  SDL_Surface *img;
  char strImg[30];

  DisplayInit();

  SDL_FillRect(ptrScreen, NULL, 0x00e7e6e4);

  dstClip.x = 0;
  dstClip.y = 0;

  for(cnt = 0; cnt < 50; cnt++) {

    sprintf(strImg, "in/%03d.png", cnt);
    img = ChargerImage(strImg);
    if(img == NULL) break;

    dstClip.w = img->w;
    dstClip.h = img->h;
    SDL_BlitSurface(img, NULL, ptrScreen, &dstClip);

    dstClip.y += img->h;
  }

  SDL_Flip(ptrScreen);

  SDL_Delay(5000);


  return 0;
}








static uint32_t GetPx(SDL_Surface *surface, uint16_t x, uint16_t y) {
  if(surface == NULL) return 0;
  return *((uint32_t*)(surface->pixels) + x + y * surface->w);
}

static void DisplayInit(void) {

  if(SDL_Init(SDL_INIT_VIDEO) < 0 ) {
    printf( "SDL Initialization failed: %s\n", SDL_GetError());
    exit(1);
  }

  atexit(SDL_Quit);
  SDL_putenv((char*)"SDL_VIDEO_WINDOW_POS=center");
  ptrScreen = SDL_SetVideoMode(320, 1024, 32, SDL_HWSURFACE | SDL_DOUBLEBUF);
  if(ptrScreen == NULL) {
    printf("Cannot rendering SDL window\n");
    exit(1);
  }
  dim.x = 0;
  dim.y = 0;
  dim.w = ptrScreen->w;
  dim.h = ptrScreen->h;
}

static SDL_Surface *ChargerImage(const char *name) {

  /*Dclaration des variables*/
  SDL_Surface* tmp = NULL;
  SDL_Surface* out = NULL;

  if(name == NULL) {
    printf("<ChargerImage>: attention, 'name' == NULL\n");
    return NULL;
  }

  /*Chargement de l'image*/
  /*Support des formats png/jpeg/bmp*/
  tmp = IMG_Load(name);

  /*Optimisation du format de l'image*/
  if(tmp != NULL) {
    out = SDL_DisplayFormatAlpha(tmp);
    SDL_FreeSurface(tmp);
    return out;
  }
  else {
    printf("<ChargerImage>: erreur: ne peut charger <%s>\n", name);
    return NULL;
  }
}
